#include "worldModel.h"

double* WorldModel::getMinimumDistance()
{
        return &minDistance_;
}

int* WorldModel::getMinimumAngle()
{
        return &minAngle_;
}

double* WorldModel::getExitDistance(){
    //return angleExit;
    return &distanceToExit;
}

double* WorldModel::getExitAngle(){
    //return angleExit;
    return &rotationToExit;
}

void WorldModel::setMinimumParameters(emc::LaserData* laser)
{
         double aux = laser->ranges[0];
         int auxangle = 0;
         for(int i = 1; i < laser->ranges.size(); ++i) {
            if(laser->ranges[i] < aux) {
                aux = laser->ranges[i];
                auxangle = i;
            }
        }
      minDistance_ = aux;
      minAngle_ = auxangle;
}


int WorldModel::findExit(emc::LaserData* laser)
{
    int i = 0; //counter for angles
    int c = 0; //counter for logging potential exit corners
    double dr = 0; //difference between 2 points (angles) separated by step
    int step = DRSTEP;//stepsize between different range comparison steps
    double treshold = DRTRESHOLD; // values to be considered interesting jump
    double freetresh = FREETRESHOLD; //values whcih will be considered nonobstacle
    int widthcounter = 0; // width of non walled space
    int largestCluster = 0; //largest collection of corner indicators, small may indicate ahole
    while(i<1000-step){ //walk through laser->ranges as far as possible
        if(laser->ranges.at(i)<freetresh){ //search for open area
            widthcounter++;
            }else if(widthcounter >= 20){
                //find exit centre:
                rotationToExit = (i - widthcounter/2)/250-2;
                //rotationToExit = 2*M_PI;
                std::cout << i;
                //rotationToExit = .2*M_PI;
                return 0; // found open exit!
            }else widthcounter = 0;

        dr = laser->ranges.at(i)-laser->ranges.at(i+step); //search for exitcorners
        if(fabs(dr)>=treshold){//points of interst
            log[c][0] = dr;
            log[c][1] = i;
            if(i==log[c-1][1]+1){
                log[c][2] = log[c-1][2]+1;
                }
            else if(i==log[c-1][1]+2){
                log[c][2] = log[c-1][2]+1;
                } else log[c][2]=1;
            c++;
        }

         i++;
    }
    /* FIND LARGEST CLUSTER */
    for(int j=0;j<999;j++){
        if(log[j][2] > largestCluster){
            largestCluster = log[j][2];
            logCorner = log[j][1];
            logdr = fabs(log[j][0]);
        }
    }

    //if(logdr<0) std::cout << "firstcornerleft";
    rotationToExit = logCorner;//-(2-logCorner/250);
    //std::cout << -(2-logCorner/250);
    distanceToExit = logdr;
    if(largestCluster < 2)return 2;
    return 1;
}
