#include "config.h"

#include <emc/io.h>
#include <emc/rate.h>
#include <emc/odom.h>

#include <cmath>
#include <iostream>

#ifndef worldModel_H
#define worldModel_H

class WorldModel
        {
private:
    double minDistance_;
    double probeValue_;
    std::vector<double> rdiffs;

    int minAngle_;
    double log[1000][3];// dr | i | l, range difference for all angles (superfluous i) l shows clustering
    int logCorner; //log predicted exitcorner
    double logdr; //distance to said corner
    double rotationToExit; //rotation necessary to aim at exit stagefront
    double distanceToExit; //distance to be travelled to said point

public:
WorldModel(){
                minDistance_ = MAX_RANGE_LRF;
                probeValue_ = 0; // CHANGE TO SOMETHING MORE LOGICAL, used in probing wallfollow

        }

    void setMinimumParameters(emc::LaserData* laser); // Method to determine the minimum distance to a wall
    double* getMinimumDistance();
    int* getMinimumAngle();

    //void scan(emc::LaserData* laser);
    int findExit(emc::LaserData* laser); //return 0 for nope, 1 for free space, 2 for corners
    double* getExitAngle();
    double* getExitDistance();


};

#endif //worldModel_H

/*
 *
    double checkExit(emc::LaserData* laser);
    double checkWallExit(emc::LaserData* laser);
    void setFollowProbeValue();
    double* getFollowProbeValue();
    double* getProbeValue(emc::LaserData* laser);
    bool evaluateProbe();
    int exitLocation(emc::LaserData* laser);
    void moveExit(emc::LaserData* laser,int cornerAngle,double cornerDistance);





    int checkStep;
    double exitCheckLimit;
    //int angleMin;
    double angleExit;
    double angleExitEntrance;
    double angleMin;
    double rotationToExit;
    double distanceToExit;
    */
